# Overview

Hortonworks (HDP 2.1.3) Apache Storm is a free and open source distributed realtime computation system. Storm makes it easy to reliably process unbounded streams of data, doing for realtime processing what Hadoop did for batch processing

Storm has many use cases: realtime analytics, online machine learning, continuous computation, distributed RPC, ETL, and more. Storm is fast: a benchmark clocked it at over a million tuples processed per second per node. It is scalable, fault-tolerant, guarantees your data will be processed, and is easy to set up and operate.

This charm will build a storm cluster consistant of:
1) Nimbus master node with following daemons will configured and loaded:
	storm-drpc                      
	storm-logviewer                 
	storm-nimbus                    
	storm-ui                        
2) Storm worker node(s) with following daemons will configured and loaded:
	storm-logviewer
	storm-supervisor  
# Usage

start a 3 node Hortonworks zookeeper quorum:
	juju deploy hdp-zookeeper hdp-zookeeper
        juju add-unit -n 2 hdp-zookeeper

        NOTE: Zookeeper must be loaded and active, to verify:
 		$ echo ruok | nc {hdp-zookeeper/0 IP address} 2181
		imok   # I'm ok must be the reply
        	$ echo stat | nc {hdp-zookeeper/0 IP address} 2181
        	Node count: 4 # check for node count 
start Apache Storm:
	juju deploy hdp-storm nimbus-server
 	juju deploy hdp-storm storm-worker
	juju add-relation nimbus-server:zookeeper hdp-zookeeper:zookeeper
	juju add-relation storm-worker:zookeeper hdp-zookeeper:zookeeper
	juju add-relation nimbus-server:nimbus storm-worker:slave

	To varify a successful deployment:
        http://{nimbus-server ip address}:8080
	
        
## Scale out Usage
        Example, adding 5 more worker nodes
        juju add-unit -n 5 storm-worker
        
        To varify a successful scale:
        http://{nimbus-server ip address}:8080

## Known Limitations and Issues



# Contact Information
amir sanjar <amir.sanjar@canonical.com>

## Upstream Project Name

- Upstream website: http://hortonworks.com/
- Upstream bug tracker https://storm.incubator.apache.org/
